#include <gnome.h>
#include "bmud.h"

GtkWidget *win;

void destructify(){
	gtk_widget_hide(win);
	return;
	}

void do_about(){
	gchar *authors[] = {"Erik Greenwald",NULL};
	GtkWidget *about=gnome_about_new(
		"BMUD","Version 0.1","GPL 1998",authors,
		"Br0kEs mud client","/usr/local/share/pixmaps/");
	gtk_widget_show(about);
	return;
	}

void do_con(){
	char *port;
	char *host;

	port=malloc(10);
	host=malloc(1000);
	

	host=gtk_entry_get_text(GTK_ENTRY(mud->hostentry));
	port=gtk_entry_get_text(GTK_ENTRY(mud->portentry));
	
//	host="207.126.70.21";
//	port="5000";

	make_connection(host,port);
	destructify();
	return;
	}

void cbox(){
	GtkWidget *hbox, *vbox, *label, *button;
	
	win=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_container_border_width (GTK_CONTAINER (win), 10);
	hbox=gtk_hbox_new(0,5);
	vbox=gtk_vbox_new(0,5);
	label=gtk_label_new("Host");
	mud->hostentry=gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox),mud->hostentry,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	gtk_widget_show(label);
	gtk_widget_show(mud->hostentry);
	gtk_widget_show(hbox);
	hbox=gtk_hbox_new(0,0);
	label=gtk_label_new("Port");
	mud->portentry=gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(hbox),mud->portentry,FALSE,FALSE,0);	
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	gtk_widget_show(label);
	gtk_widget_show(mud->portentry);
	gtk_widget_show(hbox);
	hbox=gtk_hbox_new(TRUE,0);
	button=gtk_button_new_with_label("Connect");
//	gtk_widget_grab_default (GTK_WIDGET(button));
	gtk_signal_connect(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(do_con),&mud);
	gtk_box_pack_start(GTK_BOX(hbox),button,FALSE,FALSE,0);
	gtk_widget_show(button);
	button=gtk_button_new_with_label("Cancel");
	gtk_signal_connect(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(destructify),NULL);
	gtk_box_pack_start(GTK_BOX(hbox),button,FALSE,FALSE,0);
	gtk_widget_show(button);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	gtk_container_add(GTK_CONTAINER(win),vbox);
	gtk_widget_show(hbox);
	gtk_widget_show(vbox);
	gtk_widget_show(win);
			
//	make_connection(mud,host,port);
	return;
	}

void do_gnome_menu(){
	GnomeUIInfo filemenu[]={
		{GNOME_APP_UI_ITEM,N_("Connect"), N_("Connect to a mud"),cbox, mud, NULL, GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_NEW,0, 0, NULL},
		{GNOME_APP_UI_ITEM,N_("Disconnect"), N_("Disconnect from a mud"),disconnect, NULL, NULL, GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_CLOSE,0, 0, NULL},
		GNOMEUIINFO_SEPARATOR,
		{GNOME_APP_UI_ITEM,N_("Quit"), N_("Quit bmud"),gtk_main_quit, NULL, NULL, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_QUIT,0, 0, NULL},
		GNOMEUIINFO_END
		};

	GnomeUIInfo optionmenu[]={
		{GNOME_APP_UI_ITEM,N_("Font..."),N_("Select the font"),NULL,NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_PROP,0,0,NULL},
		{GNOME_APP_UI_ITEM,N_("Colors..."),N_("Change the colors"),NULL,NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_PROP,0,0,NULL},
		GNOMEUIINFO_END
		};

	GnomeUIInfo toolmenu[]={
		{GNOME_APP_UI_ITEM,N_("Equip..."), N_("Equipment Window"),show_eq, NULL, NULL, GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_PROP,0, 0, NULL},
		{GNOME_APP_UI_ITEM,N_("Map..."), N_("the mud map"),show_map,NULL, NULL, GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_PREF,0, 0, NULL},
		GNOMEUIINFO_END
		};

	GnomeUIInfo helpmenu[]={
		{GNOME_APP_UI_ITEM,N_("About"),N_(""),do_about,NULL,NULL,
		GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ABOUT, 0,0,NULL},
		GNOMEUIINFO_END
		};
	                                                
	GnomeUIInfo mainmenu[] = {
		GNOMEUIINFO_SUBTREE(N_("File"), filemenu),
		GNOMEUIINFO_SUBTREE(N_("Options"),optionmenu),
		GNOMEUIINFO_SUBTREE(N_("Tools"),toolmenu),
		GNOMEUIINFO_SUBTREE(N_("Help"), helpmenu),
		GNOMEUIINFO_END
		};

	gnome_app_create_menus((GnomeApp*)mud->window, mainmenu);
	return;
	}


GtkWidget *spawn_gui(){
	GtkWidget *hbox, *vbox, *vscrollbar;
	
	vbox=gtk_vbox_new(FALSE,0);
	hbox=gtk_hbox_new(FALSE,0);

        gtk_signal_connect (GTK_OBJECT (mud->window), "delete_event", GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
        gtk_signal_connect (GTK_OBJECT (mud->window), "destroy", GTK_SIGNAL_FUNC (gtk_main_quit), NULL);

	do_gnome_menu(mud);

	mud->text=gtk_text_new(0,0);
	GTK_TEXT(mud->text)->has_cursor=FALSE;
	gtk_widget_show(mud->text);
	gtk_box_pack_start(GTK_BOX(hbox), mud->text, TRUE, TRUE, 0);
	vscrollbar = gtk_vscrollbar_new (GTK_TEXT(mud->text)->vadj);
	gtk_box_pack_start(GTK_BOX(hbox), vscrollbar, FALSE, FALSE, 0);
	gtk_widget_show (vscrollbar);
	gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);

	hbox=gtk_hbox_new(0,0);

	mud->stat=gtk_text_new(0,0);
	GTK_TEXT(mud->stat)->has_cursor=FALSE;
	gtk_widget_set_usize(mud->stat,150,20);
	gtk_widget_show(mud->stat);
	gtk_box_pack_start(GTK_BOX(hbox),mud->stat,FALSE,TRUE,0);
	
	mud->ent=gtk_entry_new();
	gtk_signal_connect_object (GTK_OBJECT (mud->ent), "activate", GTK_SIGNAL_FUNC (send_to_connection), NULL);
	gtk_widget_show(mud->ent);
	gtk_box_pack_start(GTK_BOX(hbox),mud->ent,TRUE,TRUE,0);

	gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,TRUE,0);

//	gtk_container_add(GTK_CONTAINER(mud->window),vbox);
	gnome_app_set_contents (GNOME_APP(mud->window),vbox);
	
	return mud->window;
	}

void textfield_add(gchar *message, int colortype){
	GtkAdjustment *adj = GTK_TEXT(mud->text)->vadj;
	int scrolled_up = FALSE;
	int numbytes=strlen(message);
	        
	if ( message[0] == '\0' )return;

	if(adj->value < adj->upper - adj->page_size){
		scrolled_up = TRUE;
		gtk_text_freeze(GTK_TEXT(mud->text));
		}

	if(colortype==MESSAGE_NONE||colortype==MESSAGE_NORMAL)
		gtk_text_insert(GTK_TEXT (mud->text), NULL,&color_white, NULL, message, -1);
	if(colortype==MESSAGE_ERR)
		gtk_text_insert(GTK_TEXT (mud->text), NULL,&color_red, NULL, message, -1);
	if(colortype==MESSAGE_ANSI){
		/* break the ansi into 2 parts, and do 'em */

//		if(message[numbytes-2]=='>'){
//			int x=numbytes;
//			while(message[x]!='\n')x--;
//			disp_ansi((gchar *)&message[x],mud->stat);
//			message[x]=0;
//			}                

		disp_ansi(message,mud->text);
		}

	if(scrolled_up)
		gtk_text_thaw(GTK_TEXT(mud->text));
	else
		if(adj->value < adj->upper - adj->page_size)
			gtk_adjustment_set_value(adj, adj->upper - adj->page_size);

	gtk_widget_grab_focus(GTK_WIDGET(mud->ent));
	return;
}


